/*-------------------------------------------------------------------------------------------------------------------
        This javascript file contains functions used for breadcrumb.
        
        CVS Version     : $Id: breadcrumb.js,v 1.8 2003/05/13 06:11:56 roym Exp $
        ---------------------------------------
        Modified
        V       Date                    Who             What
        1.0     04.03.03                RM              Initial version
        
        
        File history:
        $Log: breadcrumb.js,v $
        Revision 1.8  2003/05/13 06:11:56  roym
        Cleand up comments

        Revision 1.7  2003/04/09 15:41:15  roym
        fix for categories beeing removed from default trail when parentcats parameter was missing.

        Revision 1.6  2003/04/07 12:53:14  roym
        Fixed bug when default trail was used. Duplicate trails for categories with pagenumbers.

---------------------------------------------------------------------------------------------------------------------
This file contains javascript function used for breadcrumb:
setCrumbTrail(value)
addToCrumbTrail(value)
getCookie(name)
tidyCookie(lastcommand, parentcats)
writeCrumbTrail(strstorelangcat, parentcats, lastcommand)
writeDefaultCrumbTrail(breadCrumbString)
hasBreadCrumbCookie()
GetQueryParameter(strURL, strParameterName, strDefaultParameterValue)

Format of cookietrail will be:
<id>|<name>|<type>|<parentcats>|<chapter>|<pageNumber>##<id>|<name>|<type>|<parentcats>|<chapter>|<pageNumber>

The separator for trail is ##, separator for trail parts is |

This means ## and | can not be used in product name ,produt type and category name. If this needs to be changed. Make sure to change separator in 
the youarehere.jsp file also. This is where the defaultbreadcrumb is added to the cookie.
----------------------------------------------------------------
*/
var COOKIE_NAME = "crumbtrail";

/*
----------------------------------------------------------------
Function for creating cookie
----------------------------------------------------------------
*/
function setCrumbTrail(value) {
	document.cookie = COOKIE_NAME + "=" + escape(value);
}

/*
----------------------------------------------------------------
Function for adding trail to trailcrumb cookie
Checks for duplicate before adding new trail (without chapter and pagenumber since they can change)
Checks if chapter or pagenumber has changed
----------------------------------------------------------------
*/
function addToCrumbTrail(value, defaultvalue) {
	var newcrumbtrail = '';			
	var currentcookie = getCookie(COOKIE_NAME);
	var newcookie;
	
	// check if cookie exists. If not use default trail
	if(currentcookie) { newcookie = currentcookie; }
	else { newcookie = defaultvalue;	}

	var trailWithoutPagenumber = value.substring(0,value.lastIndexOf('|')); // remove pagenumber
	var trailwithoutChapterAndPagenumber = trailWithoutPagenumber.substring(0,trailWithoutPagenumber.lastIndexOf('|')); // remove chapter
	var pos = newcookie.indexOf(trailwithoutChapterAndPagenumber);  // check for occurance without chapter and pagenumber element (id|name|type|parentcats|chapter|pageNumber)

	if (pos == -1){
		// trail does not exist in cookie add new trail
		setCrumbTrail(newcookie+"##"+value);
	}
	else {
		// check if chapter or pagenumber has changed
		var trailArray = newcookie.split('##');	
		var newTrailpart = value.split('|');
			
		for (var i = 0; i < trailArray.length; i++) {

			trailpart = trailArray[i].split('|'); // 0 - catgroupId, 1 - name, 2 - type, 3 - parentcats, 4 - chapter, 5 - pageNumber
			
			// check if catalogId is same								
			if(trailpart[0] == newTrailpart[0]) {					
				// check if chapter has changed, pagenumber could also have changed - replace with new value
				if(trailpart[4] != newTrailpart[4]) {
					trailArray[i] = trailpart[0] + "|" + trailpart[1] + "|" + trailpart[2] + "|" + trailpart[3] + "|" + newTrailpart[4] + "|" + newTrailpart[5];
				}
				else if(trailpart[5] != newTrailpart[5]) { // check if pagenumber has changed
					trailArray[i] = trailpart[0] + "|" + trailpart[1] + "|" + trailpart[2] + "|" + trailpart[3] + "|" + trailpart[4] + "|" + newTrailpart[5];
				}
			}
			
			// build new trail crumb
			if (newcrumbtrail == '') { newcrumbtrail = trailArray[i]; }
			else { newcrumbtrail = newcrumbtrail + "##" + trailArray[i]; }
		}
		
		// set new cookie
		setCrumbTrail(newcrumbtrail);
	}	
}

/*
----------------------------------------------------------------
Function for getting cookie
----------------------------------------------------------------
*/
function getCookie(name) {
	var search = name + "=";
	if (document.cookie.length > 0) { // if there are any cookies
		offset = document.cookie.indexOf(search);
		
		if (offset != -1) { // if cookie exists
			offset += search.length;
			// set index of beginning of value
			end = document.cookie.indexOf(";", offset);
			// set index of end of cookie value
			if (end == -1)
				end = document.cookie.length;
				
			return unescape(document.cookie.substring(offset, end));
		}
	}
}

/*
----------------------------------------------------------------
Function for tidying the cookie. Removing obsolete trail enties
----------------------------------------------------------------
*/
function tidyCookie(lastcommand, parentcats, activeid) {
	var cookietrail = getCookie(COOKIE_NAME);

	if(!cookietrail) { return false; }
	
	if(parentcats == '') { 
		setCrumbTrail('');  // delete old cookie
		return false;
	}

	var newcrumbtrail = '';
	var parentcatsArray = parentcats.split('*');
	var trailArray = cookietrail.split('##'); // create array of trails

	if(lastcommand == 'CategoryDisplay') {
		// Since last command is CategoryDisplay all products in crumbtrail should be removed..
		if(parentcatsArray && parentcatsArray.length > 0 && parentcatsArray[0] != '') {
			parentcatsArray.sort();
						
			for (var i = 0; i < trailArray.length; i++) {				
				for (var n = 0; n < parentcatsArray.length; n++) {
					// get parts of trail
					trailpart = trailArray[i].split('|');  // 0 - catgroupId, 1 - name, 2 - type, 3 - parentcats, 4 - chapter, 5 - pagenumber
					
					// only save trails that exsist in parentcats
					if (trailpart[0] == parentcatsArray[n]) {
						if (newcrumbtrail == '')
							newcrumbtrail = trailArray[i];
						else
							newcrumbtrail = newcrumbtrail + "##" + trailArray[i];
					}					
				}
			} // end for loop with trailArray

			// set new cookie
			setCrumbTrail(newcrumbtrail);
			 
		} // end if parentcatsArray exists
		else {						
			return false;		
		}
	}
	else if (lastcommand == 'ProductDisplay') {
		// Since this is ProductDisplay the product part of the trail needs to remain. Handle this specially.
		if(parentcatsArray && parentcatsArray.length > 0 && parentcatsArray[0] != '') {
			parentcatsArray.sort();
									
			for (var i = 0; i < trailArray.length; i++) {				
				// get parts of trail
				trailpart = trailArray[i].split('|');  // 0 - catgroupId, 1 - name, 2 - type, 3 - parentcats, 4 - chapter, 5 - pagenumber

				if(trailpart[2] != 'prod') {
					// category check if it is part of parentcats
					for (var n = 0; n < parentcatsArray.length; n++) {
						// only save trails that exist in parentcats or if it is a product.
						if (trailpart[0] == parentcatsArray[n]) {							
							if (newcrumbtrail == '')
								newcrumbtrail = trailArray[i];
							else
								newcrumbtrail = newcrumbtrail + "##" + trailArray[i];
						}			
					} // end for loop parentcatsArray
				}
				else {
					// product, check that productId is same as last aquired product if not remove product from trail					
					if(trailpart[0] == activeid) {
						if (newcrumbtrail == '')
							newcrumbtrail = trailArray[i];
						else
							newcrumbtrail = newcrumbtrail + "##" + trailArray[i];
					}
				}
					
			} // end for loop with trailArray
			
			// set new cookie
			setCrumbTrail(newcrumbtrail);
			 
		} // end if parentcatsArray exists
		else {			
			return false;	
		}	
	}	

	return true;
}

/*
----------------------------------------------------------------
Function for writing breadcrumb trail to page. The function writes to a <span> tag with id="breadcrumb".
Before writing the breadcrumb the breadcrumb cookie is updated with new parentcats and type. This is done by calling tidyCookie() function.
This function returns true when every thing has gone OK. If something fails false is returned. This happends when cookie is not found or parentCats is empty.
----------------------------------------------------------------
*/
function writeCrumbTrail(strstorelangcat, parentcats, lastcommand, activeid) {
	// Tidy cookie for obsolete trails
	if ( !tidyCookie(lastcommand, parentcats, activeid) ) { return false; } // if tidyCookie returns false, return false so default trail is used
	
	var parentcatsArray = parentcats.split('*');	
	var cookietrail = getCookie(COOKIE_NAME);
	
	if(!cookietrail) { return false; } // cookie not found. Return false so default trail is used
	
	var trailArray = cookietrail.split('##'); // create array of trails located in cookie
	var breadCrumbString = "";	
	
	// check that activeid exists in trailcrumb, if not an error has occured and default crumbtrail should be used. (Ex. user has bookmarked a page)
	if( FindTrailInArray(trailArray, activeid, lastcommand) == -1 ) {
		setCrumbTrail('');  // delete cookie that contains error
		return false;
	}

	// check if parentcats exist if not use default crumb trail
	if(parentcatsArray && parentcatsArray.length > 0 && parentcatsArray[0] != '') {
		parentcatsArray.sort();
		
		for (var i = 0; i < trailArray.length; i++) {			
			for (var n = 0; n < parentcatsArray.length; n++) {
				trailpart = trailArray[i].split('|');  // 0 - catgroupId, 1 - name, 2 - type, 3 - parentcats, 4 - chapter, 5 - pagenumber
				
				// only show trails that exist in parentcats.
				if (trailpart[0] == parentcatsArray[n] && trailpart[2] != 'prod') {
					// category part of parentcats found
					
					if(i == trailArray.length -1) {
						// append text to crumbtrail
						breadCrumbString = breadCrumbString + '<img src="/ms/img/navigation/arrowred8x6.gif" width="8" height="6" alt=""><span class="orange1">&nbsp;' + trailpart[1] + '</span><span class="spacer1">&nbsp;</span>';
					}
					else { // append link to crumbtrail						
						// check if chapter exists
						if(trailpart[4] != '') {
							// check if partnumber exists
							if(trailpart[5] != '') {
								breadCrumbString = breadCrumbString + '<img src="/ms/img/navigation/arrowred8x6.gif" width="8" height="6" alt=""><a href="CategoryDisplay?' + strstorelangcat + '&categoryId=' + trailpart[0] + '&cattype=' + trailpart[2] + '&parentCats=' + trailpart[3] + '&chapterId=' + trailpart[4] + '&pageNumber=' + trailpart[5] + '">&nbsp;' + trailpart[1] + '</a><span class="spacer1">&nbsp;</span>';
							}
							else {
								breadCrumbString = breadCrumbString + '<img src="/ms/img/navigation/arrowred8x6.gif" width="8" height="6" alt=""><a href="CategoryDisplay?' + strstorelangcat + '&categoryId=' + trailpart[0] + '&cattype=' + trailpart[2] + '&parentCats=' + trailpart[3] + '&chapterId=' + trailpart[4] + '">&nbsp;' + trailpart[1] + '</a><span class="spacer1">&nbsp;</span>';
							}
						}
						else {
							// check if pagenumber exists
							if(trailpart[5] != '') {
								breadCrumbString = breadCrumbString + '<img src="/ms/img/navigation/arrowred8x6.gif" width="8" height="6" alt=""><a href="CategoryDisplay?' + strstorelangcat + '&categoryId=' + trailpart[0] + '&cattype=' + trailpart[2] + '&parentCats=' + trailpart[3] + '&pageNumber=' + trailpart[5] + '">&nbsp;' + trailpart[1] + '</a><span class="spacer1">&nbsp;</span>';								
							}
							else {
								breadCrumbString = breadCrumbString + '<img src="/ms/img/navigation/arrowred8x6.gif" width="8" height="6" alt=""><a href="CategoryDisplay?' + strstorelangcat + '&categoryId=' + trailpart[0] + '&cattype=' + trailpart[2] + '&parentCats=' + trailpart[3] + '">&nbsp;' + trailpart[1] + '</a><span class="spacer1">&nbsp;</span>';
							}
						}
					}
				}
				else if(trailpart[2] == 'prod') {
					// product found append text
					breadCrumbString = breadCrumbString + '<img src="/ms/img/navigation/arrowred8x6.gif" width="8" height="6" alt=""><span class="orange1">&nbsp;' + trailpart[1] + '</span><span class="spacer1">&nbsp;</span>';
					break; // exit for loop with parentcatsArray
				}							
			}
		}
	} // end if parentcatsArray exists
	else {		
		return false; // Use default trailcrumb
	}

	// check if breadcrumb element exists and write breadcrumb
	if (document.getElementById('breadcrumb')) {	
		document.getElementById('breadcrumb').innerHTML = breadCrumbString;
	}
	else {
		alert('breadcrumb id not found');
		document.write('Error: breadcrumb id not found. Error in HTML page.');
		return false;
	}
		
	return true; // return true when every thing is OK.
}

/*
----------------------------------------------------------------
Returns true if breadcrumb cookie exists and false if not
----------------------------------------------------------------
*/
function hasBreadCrumbCookie() {
	var cookie = getCookie(COOKIE_NAME);
	
	if(cookie) {
		return true;		
	}
	else {
		return false;
	}
}

/*
----------------------------------------------------------------
Writes the default breadcrumb to the span tag with id='breadcrumb'
----------------------------------------------------------------
*/
function writeDefaultCrumbTrail(breadCrumbString) {
	if (document.getElementById('breadcrumb')) {	
		document.getElementById('breadcrumb').innerHTML = breadCrumbString;
	}
	else {
		alert('breadcrumb id not found');
		document.write('Error: breadcrumb id not found.');
	}		
}

/*
----------------------------------------------------------------
Function for returning parameter from querystring
----------------------------------------------------------------
*/
function GetQueryParameter(strURL, strParameterName, strDefaultParameterValue) {
	soURLOriginal = new String(strURL);
	soURL = new String(soURLOriginal.toLowerCase());
	soParameterName = new String(strParameterName);
	iParameterNameIndex = soURL.indexOf(soParameterName.toLowerCase() + "=", 0);
	
	if(iParameterNameIndex == -1) { 
		strParameterValue = strDefaultParameterValue;
	}
	else { 
		iNextParameterNameIndex = soURL.indexOf("&", iParameterNameIndex + soParameterName.length);
		if(iNextParameterNameIndex == -1) { 
			strParameterValue = soURL.substring(iParameterNameIndex + soParameterName.length +1, soURL.length); 
		}
		else {
			strParameterValue = soURL.substring(iParameterNameIndex + soParameterName.length +1, iNextParameterNameIndex);
		}
	}
	return strParameterValue;
}

/*
----------------------------------------------------------------
Function for finding trail in trail array
----------------------------------------------------------------
*/
function FindTrailInArray(array, value, lastcommand) 
{ 
	var returnValue = -1; 
	for(var i = 0; i < array.length; i++) 
	{ 
		if(lastcommand == 'ProductDisplay') {
			pos = array[i].indexOf(value);
			pos2 = array[i].indexOf('prod');
		}
		else {
			pos = array[i].indexOf(value);
			pos2 = 1;			
		}
	
		if (pos != -1 && pos2 != -1){			
			returnValue = i; 
			break;
		}
	} 
	return returnValue; 
}